extensions [matrix]

globals [
 earnhist
 mkthist
 current-msgs
 oa
 ob
 agent-oa
 agent-ob
 tradelist
 memhist
 dlist
 dmatrix
 dfull
 ticksize
 oa-max
 ob-min
 lambda-list
 price
 et
 et1
 et2
 et3
 et4
 et5
 season-list
]

turtles-own[
  fcast-type
  lambda
  risky
  riskless
  phigh
  estvalue
  payoff
  msg
  p-ask
  best-ask
  p-bid
  best-bid
  memlength
  myhist
  informed
  action

]


to setup
  clear-all
  set-default-shape turtles "dot"
  set earnhist (list)
  set mkthist [ ]
  set tradelist (list)
  set current-msgs [ ]
  set memhist (list)
  set dlist (list)
  set dmatrix (list)
  set dfull (list)
  set lambda-list (list 0.0835 0.0829 0.0718 0.0869 0.0846 0.0815 0.0855 0.076 0.0918 0.0797 0.0834)
  set price 0
  
  set season-list n-values n [0]
  let i 0
  while [i < n-seasonal] [set season-list replace-item i season-list 1 set i i + 1]
  set earnhist lput (5 + random-float 2.5) earnhist
  set i 0
  while [i < 20] [set earnhist lput (2.5 + .8 * item i earnhist + random-normal 0 1) earnhist set i i + 1]
  set et last earnhist
  set et1 item (length earnhist - 2) earnhist
  set et2 item (length earnhist - 3) earnhist
  set et3 item (length earnhist - 4) earnhist
  set et4 item (length earnhist - 5) earnhist
  set et5 item (length earnhist - 6) earnhist
    
  set oa (sum sublist earnhist (length earnhist - 4) (length earnhist)) / .03
  set ob sum sublist earnhist (length earnhist - 4) (length earnhist)
  set ob-min sum sublist earnhist (length earnhist - 4) (length earnhist)
  set oa-max (sum sublist earnhist (length earnhist - 4) (length earnhist)) / .03
  set agent-oa -1
  set agent-ob -1
  set ticksize .1
    set-current-plot "price"
    set-plot-y-range 500 800
    set-current-plot "market"
    set-plot-y-range 265 1200
 
 
  

  crt n [
    set riskless 4000
    set risky 100
    set lambda random-normal 0.08 0.005
    set fcast-type item who season-list
    set informed 0
    set estvalue 0
    set payoff 0
    set msg (list)
    set memlength memory-length
    set myhist (list)
    set action 0
    
  ]

end

to go 
  remember-history
  fill-dlist
  ifelse (infoswitch = true) [
  send-information-bb][send-information]
   valuation
   build-expectations
   send-message
   
    do-plots
 tick

end

to send-information
  
    
      if ticks mod period = 0 [
        set earnhist bf earnhist
        set earnhist lput (2.5 + .8 * item (length earnhist - 1) earnhist + random-normal 0 1) earnhist
          set et last earnhist
          set et1 item (length earnhist - 2) earnhist
          set et2 item (length earnhist - 3) earnhist
          set et3 item (length earnhist - 4) earnhist
          set et4 item (length earnhist - 5) earnhist
          set et5 item (length earnhist - 6) earnhist
        ]
    
    
    
end

to send-information-bb
  
end


to valuation
  ask turtles[
    let ft1 0
    let ft2 0
    let ft3 0
    let ft4 0
    
    ifelse fcast-type = 0 [
      
      set ft1 2.5 + .8 * last earnhist
      set ft2 2.5 + .8 * ft1
      set ft3 2.5 + .8 * ft2
      set ft4 2.5 + .8 * ft3
      
      set estvalue (ft1 + ft2 + ft3 + ft4) / lambda
      
      
      
      
      ][
      
      
      set estvalue (sum sublist earnhist (length earnhist - 4) (length earnhist)) / lambda
      
      
      
      ]
    
    
    
    
  ]
    
end


to fill-dlist
  
  set dmatrix (list)
  set dfull (list)
  set dlist (list)
  if empty? memhist = false [
    let d map [item 2 ?] memhist
  
  
    set d remove-duplicates d
    set d sort d
    ;write "d"
    ;show d
    let dval 0
    let numask 0
    let numbid 0
    let ta 0
    let tb 0
    let ra 0
    let rb 0
    let found 0
    let i 0
    let index 0
    let pa 0
    let qb 0
    foreach d [
      
      set dval ?
      set numask 0
      set numbid 0
      set ta 0
      set tb 0
      set ra 0
      set rb 0
      set index 0
      foreach memhist [
        ifelse(item 0 ? = -1 and item 2 ? = dval) [
          
          set numbid numbid + 1
          
          
          ]
        [
          ifelse(item 1 ? = -1 and item 2 ? = dval) [
          
            set numask numask + 1
          
          ][
          
          ; check for a trade
          if(item 0 ? > -1 and item 1 ? > -1 and item 2 ? = dval) [
 
          set found 0
          set i index - 1
          
 
           while [found = 0] [
        ifelse (item 1 item i memhist = -1 and item 2 item i memhist = dval) [
          ;if most recent was an ask
          set found 1
          set ta ta + 1
           ] 
        
        [
          ifelse (item 0 item i memhist = -1 and item 2 item i memhist = dval) [
            ;if most recent was a bid
            set found 1
            set tb tb + 1
             ]
          
          [
          ; if not found yet, iterate backwards 
          set i i - 1

          ]
      ]
          
          
            
          ]
          
          ]]]
          set index index + 1
        ]
      
      set dmatrix lput (list dval numask ta (numask - ta) numbid tb (numbid - tb)) dmatrix
    
    ]
    
    let alessb 0
    let bntgrtb 0
    let bgrta 0
    let antlessa 0
    let tagrta 0
    let tblstb 0
    foreach dmatrix [
      set dval item 0 ?
      set alessb 0
      set bntgrtb 0
      set bgrta 0
      set antlessa 0
      set tagrta 0
      set tblstb 0
      foreach dmatrix [
        if item 0 ? < dval [
          set alessb alessb + item 1 ?
          set antlessa antlessa + item 3 ?
          set tblstb tblstb + item 5 ?  
          
          ]
        
         if item 0 ? > dval [
          set bgrta bgrta + item 4 ?
          set bntgrtb bntgrtb + last ?
          set tagrta tagrta + item 2 ?
          
          ]
        
        
        ]
      
      let dtemp (list)
      foreach ? [set dtemp lput ? dtemp]
     set dtemp lput (alessb + item 1 ?) dtemp
     set dtemp lput (antlessa + item 3 ?) dtemp
     set dtemp lput (bgrta + item 4 ?) dtemp
     set dtemp lput (bntgrtb + item 6 ?) dtemp
     set dtemp lput (tagrta + item 2 ?) dtemp
     set dtemp lput (tblstb + item 5 ?) dtemp
     
     set dfull lput dtemp dfull
      
      ]
    
    ;dfull layout =
    ; 0 - dval 
    ; 1 - numask 
    ; 2- ta 
    ; 3 - ra 
    ; 4 - numbid 
    ; 5 - tb 
    ; 6 - rb 
    ; 7 - alessb 
    ; 8 - antlessa 
    ; 9 - bgrta 
    ; 10 - bntgrtb
    ; 11 - tagrta
    ; 12 - tblstb 
    
    foreach dfull [
     ifelse ((item 11 ? + item 9 ? + item 8 ?) > 0) [set pa ((item 11 ? + item 9 ?) / (item 11 ? + item 9 ? + item 8 ?))] [set pa 0]
     ifelse ((item 12 ? + item 7 ? + item 10 ?) > 0) [set qb ((item 12 ? + item 7 ?) / (item 12 ? + item 7 ? + item 10 ?))] [set qb 0]
     if (item 0 ? > ob and item 0 ? < oa) [set dlist lput (list (item 0 ?) pa qb) dlist]
      
    ]
 
    
    
    
    
    
  ]

  set dlist fput (list ob 1 0) dlist
  set dlist lput (list oa 0 1) dlist



end



to build-expectations

    ask turtles [
      find-ask
      find-bid 
   let ask-ob ob - estvalue
   let bid-oa estvalue - oa   
   let best-action max (list p-ask p-bid ask-ob bid-oa)

   ;if an ask is optimal
   
   ifelse best-action <= 0 [ set msg (list) set action 0 ]
   [
    ifelse best-action = p-ask [
      set msg (list who -1 best-ask)
      set payoff best-ask - estvalue
      set action 1
      ]
    [
      ;otherwise if a bid is optimal
      ifelse best-action = p-bid [
      
      set msg (list -1 who best-bid)
      set payoff estvalue - best-bid
      set action 1
      ][
      ;otherwise if taking the ob is optimal
      ifelse best-action = ask-ob [
        set msg (list who -1 ob)
        set payoff ob - estvalue
        set action 1
        ][
        ;otherwise taking the oa must be optimal
          set msg (list -1 who oa)
          set payoff estvalue - oa
          set action 1
    ]]]]
        
    ]
   
   
end

to find-ask
   let x1 ob
   let px1 1
   let y1 oa
   let py1 0  
   
   let x2 ob
   let px2 1
   let y2 oa
   let py2 0
   
   let idx0 0
   let idx1 0
   let idx2 0
    
    
    
    ifelse length dlist = 2 [ 
         set x1 item 0 item 0 dlist
         set px1 item 1 item 0 dlist
         set y1 item 0 item 1 dlist
         set py1 item 1 item 1 dlist  
   
         set x2 item 0 item 0 dlist
         set px2 item 1 item 0 dlist
         set y2 item 0 item 1 dlist
         set py2 item 1 item 1 dlist  
      
      
      ]
    
    [

      let dasks map [(list (item 0 ?) ((item 0 ? - estvalue) * item 1 ?))] dlist
      let dask1 but-first dasks
      set dask1 but-last dask1
      let maxdasks reduce [ifelse-value (item 1 ?1 > item 1 ?2) [?1] [?2]] dask1

      
          ;interpolate over j-1, j, j +1
          
        
         set idx1 position maxdasks dasks
         set idx0 idx1 - 1
         set idx2 idx1 + 1
         
         
         set x1 item 0 item idx0 dlist
         set px1 item 1 item idx0 dlist
         set y1 item 0 item idx1 dlist
         set py1 item 1 item idx1 dlist 
         
         set x2 item 0 item idx1 dlist
         set px2 item 1 item idx1 dlist 
         set y2 item 0 item idx2 dlist
         set py2 item 1 item idx2 dlist
          
          
          ] 
        
   
   ;perform two interpolations, choose highest payoff
   let B1 interpolate x1 y1 px1 py1
   let B2 interpolate x2 y2 px2 py2
;   show word "b1 " B1
;   show word "B2 " B2
   
   
   set p-ask 0
   set best-ask 0
   let i 0
   let istop 0
   
    ;evaluate 1st interpolation
   set i ob + ticksize
   if x1 > ob [set i x1]
   set istop oa - ticksize
   if y1 < oa [set istop y1]
   while [i <= istop] [

     let eval (i - estvalue) * (i * item 0 B1 + item 1 B1)

     if eval > p-ask [
       set p-ask eval
       set best-ask i
     ]

     set i i + ticksize]
   
   
   
   ;evaluate 2nd interpolation
   set i ob + ticksize
   if x2 > ob [set i x2]
   set istop oa - ticksize
   if y2 < oa [set istop y2]
      while [i <= istop] [

     let eval (i - estvalue) * (i * item 0 B2 + item 1 B2)

     if eval > p-ask [
       set p-ask eval
       set best-ask i
     ]

     set i i + ticksize]
      
      
   

  

end



to find-bid
  
   let x1 ob
   let px1 0
   let y1 oa
   let py1 1  
   
   let x2 ob
   let px2 0
   let y2 oa
   let py2 1
   
   let idx0 0
   let idx1 0
   let idx2 0
    
    
    
    ifelse length dlist = 2 [ 
         set x1 item 0 item 0 dlist
         set px1 item 2 item 0 dlist
         set y1 item 0 item 1 dlist
         set py1 item 2 item 1 dlist  
   
         set x2 item 0 item 0 dlist
         set px2 item 2 item 0 dlist
         set y2 item 0 item 1 dlist
         set py2 item 2 item 1 dlist  
      
      
      ]
    
    [
      
      let dasks map [(list (item 0 ?) ((estvalue - item 0 ?) * item 2 ?))] dlist
      let dask1 but-first dasks
      set dask1 but-last dask1
       
      let maxdasks reduce [ifelse-value (item 1 ?1 > item 1 ?2) [?1] [?2]] dask1
      
      
          ;interpolate over j-1, j, j +1
          
        
         set idx1 position maxdasks dasks
         set idx0 idx1 - 1
         set idx2 idx1 + 1

         
         set x1 item 0 item idx0 dlist
         set px1 item 2 item idx0 dlist
         set y1 item 0 item idx1 dlist
         set py1 item 2 item idx1 dlist 
         
         set x2 item 0 item idx1 dlist
         set px2 item 2 item idx1 dlist 
         set y2 item 0 item idx2 dlist
         set py2 item 2 item idx2 dlist
          
          
          ] 
   
   

    
   ;perform two interpolations, choose highest payoff
   let B1 interpolate x1 y1 px1 py1
   let B2 interpolate x2 y2 px2 py2

   
   
   set p-bid 0
   set best-bid 0
   let i 0
   let istop 0
   
    ;evaluate 1st interpolation
   set i ob + ticksize
   if x1 > ob [set i x1]
   set istop oa - ticksize
   if y1 < oa [set istop y1]
   while [i <= istop] [

     let eval (estvalue - i) * (i * item 0 B1 + item 1 B1)

     if eval > p-bid [
       set p-bid eval
       set best-bid i
     ]

     set i i + ticksize]
   
   
   
   ;evaluate 2nd interpolation
   set i ob + ticksize
   if x2 > ob [set i x2]
   set istop oa - ticksize
   if y2 < oa [set istop y2]
      while [i <= istop] [

     let eval (estvalue - i) * (i * item 0 B2 + item 1 B2)

     if eval > p-bid [
       set p-bid eval
       set best-bid i
     ]

     set i i + ticksize]
  



  
end



to send-message
   
   ;choose a msg to be accepted by the market
  let sumpayoff 0 
  ask turtles with [action = 1] [set sumpayoff sumpayoff + payoff]
    
  let draw random-float sumpayoff
  
  let i 0
  let found 0 
  let sumpayoff2 0
  while [found = 0 and i < n]
  [
    ifelse [action] of turtle i = 1 [
    ifelse (draw < sumpayoff2 + [payoff] of turtle i) [set found 1]
    [
    set sumpayoff2 sumpayoff2 + [payoff] of turtle i
       set i i + 1]  
    
    ] [set i i + 1 ]
 
  ]
  if i = n [set i (i - 1)]

   
   ifelse item 0 [msg] of turtle i = -1 [
     ;if the msg is a bid, then check to see whether the bid is equal to the outstanding ask
     
     
     
     ifelse item 2 [msg] of turtle i = oa [
       ;if the msg is an acceptance of an outstanding ask then trade occurs and oa,ob are reset
       set mkthist lput (list agent-oa i item 2 [msg] of turtle i) mkthist
       set tradelist lput 1 tradelist
       set oa oa-max
       set ob ob-min
       set agent-oa -1
       set agent-ob -1
       ] [
       ;otherwise the msg of the turtle becomes the ob
       set mkthist lput [msg] of turtle i mkthist
       set tradelist lput 0 tradelist
       set ob item 2 [msg] of turtle i
       set agent-ob i
       
       ]
     ]
   [
     ;If the msg is an ask, then check to see whether the ask is equal to the outstanding bid
      ifelse item 2 [msg] of turtle i = ob [
       ;if the msg is an acceptance of an outstanding bid then trade occurs and oa,ob are reset
       set mkthist lput (list i agent-ob item 2 [msg] of turtle i) mkthist
       set tradelist lput 1 tradelist
       set oa oa-max
       set ob ob-min
       set agent-oa -1
       set agent-ob -1
       ] [
       ;otherwise the msg of the turtle becomes the oa
       set mkthist lput [msg] of turtle i mkthist
       set tradelist lput 0 tradelist
       set oa item 2 [msg] of turtle i
       set agent-oa i
       
       ]
     
     
     
     ]
   

  ask turtles [ 
    set payoff 0
    set msg (list) 
    ]
   
end


to remember-history
  let S (list) ;list of trades
  let rhist (list) ;rememberd history
  let sum-s 0 ; a counter to count the number of trades 
  let found 0
  let i 0
  foreach tradelist [
    set sum-s sum-s + ?
    set S lput sum-s S
  ]
  
  ifelse (empty? S = false and last S > memory-length) [
  
  let first-mem last S - memory-length
  let n-first position first-mem S + 1
  set rhist sublist mkthist n-first length S
 

  ] 
  
  [set rhist mkthist 

    ]
  
  
  ;check for empty list
  if empty? rhist = false [
    ;delete oa and ob from observed hist
  ifelse item 0 last rhist = -1 [ 
    ;if the last item is a bid, delete it and look for an outstanding ask
    set rhist but-last rhist
    if empty? rhist = false [
    set found 0
    set i length rhist - 1
      while [found = 0 and empty? rhist = false] [
        ifelse item 1 item i rhist = -1 [
          ;if found most recent ask
          set found 1
          set rhist remove-item i rhist
          
           ] [
       ifelse (item 0 item i rhist > -1 and item 1 item i rhist > -1)[
         
         ;if found a trade, no oa to delete, stop looking
         set found 1
         
         ]
        [;otherwise iterate backwards, if nothing pops up, only one type of trade in the market, so stop looking at end of list. 
          set i i - 1
          if i < 0 [set found 1]
          ]]
      ]
    
    
  ]] [
  
  ; if the last item is not a bid, check for an ask, but if not an ask, do nothing to the history because the last item is a trade
  if item 1 last rhist = -1 [
    ; if the last item is an ask, delete it and look for last bid
    set rhist but-last rhist
 
    if empty? rhist = false[  
    set found 0
    set i (length rhist - 1) 
      while [found = 0 and empty? rhist = false] [
    
        ifelse item 0 item i rhist = -1 [
          ;if found most recent bid
          set found 1
          set rhist remove-item i rhist
          
           ] 
        
       [
       ifelse (item 0 item i rhist > -1 and item 1 item i rhist > -1)[
         
         ;if found a trade, no oa to delete, stop looking
         set found 1
         
         ]
        [;otherwise iterate backwards if nothing pops up, only one type of trade in the market, so stop looking at end of list. 
          set i i - 1
          if i < 0 [set found 1]
          ]]
     ]
       
  ]]
  
  
  ]]
  
set memhist rhist
 
  
  
end



to-report interpolate [x y px py]
   let A matrix:from-row-list (list (list x 1) (list y 1)) 
   let C matrix:from-column-list (list (list px py)) 
   let B matrix:get-column matrix:solve A C 0
   report B
end



to do-plots
 set-current-plot "market"
 ifelse item 0 last mkthist = -1 [
   ;if the msg is a bid
   set price -1
   set-current-plot-pen "bid"
   plotxy ticks item 2 last mkthist
 ][
 ;check for a transaction
 ifelse item 1 last mkthist = -1 [
   ;If the msg is an ask
   set price -1
    set-current-plot-pen "ask"
   plotxy ticks item 2 last mkthist
   ][
   ;otherwise, it is a transaction
   set price item 2 last mkthist
     set-current-plot-pen "transact"
   plotxy ticks item 2 last mkthist
   
   set-current-plot "pe"
   ;set-current-plot-pen "pe-ratio"
   plotxy ticks ( (sum sublist earnhist (length earnhist - 4) (length earnhist)) / price)

   
   set-current-plot "price"
   set-current-plot-pen "transact"
   plotxy ticks item 2 last mkthist
   
   ]]
    set-current-plot "earnings"
    set-current-plot-pen "default"
    plot last earnhist
    
    if ticks mod period = 0 [
      set-current-plot "price"
      set-current-plot-pen "line"
      plot-pen-down
      plotxy ticks 500 plotxy ticks 800
      plot-pen-up]
 
end

@#$#@#$#@
GRAPHICS-WINDOW
220
10
395
206
1
1
55.0
1
1
1
1
1
0
1
1
1
-1
1
-1
1
0
0
1
ticks

SLIDER
14
61
186
94
n
n
5
100
10
1
1
NIL
HORIZONTAL

SLIDER
16
163
188
196
period
period
100
1000
500
20
1
NIL
HORIZONTAL

SLIDER
16
236
211
269
memory-length
memory-length
1
10
9
1
1
NIL
HORIZONTAL

PLOT
592
10
1232
286
Market
ticks
price
0.0
1000.0
40.0
60.0
true
true
PENS
"ask" 1.0 2 -2674135 true
"bid" 1.0 2 -13345367 true
"transact" 1.0 2 -10899396 true

BUTTON
19
14
85
47
setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
95
14
158
47
go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

PLOT
6
305
586
732
price
NIL
NIL
0.0
1000.0
40.0
50.0
true
true
PENS
"transact" 1.0 2 -16777216 true
"line" 1.0 1 -2674135 true

SWITCH
339
250
459
283
infoswitch
infoswitch
1
1
-1000

SLIDER
14
97
186
130
n-seasonal
n-seasonal
0
n
10
1
1
NIL
HORIZONTAL

PLOT
597
302
1235
580
earnings
ticks
earnings
0.0
1000.0
0.0
20.0
true
false
PENS
"default" 1.0 0 -16777216 true
"pe-ratio" 1.0 2 -13345367 true

PLOT
600
599
1234
749
pe
NIL
NIL
0.0
1000.0
0.05
0.1
true
false
PENS
"default" 1.0 2 -16777216 true

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.1.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="experiment" repetitions="100" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="4500"/>
    <metric>price</metric>
    <metric>et</metric>
    <metric>et1</metric>
    <metric>et2</metric>
    <metric>et3</metric>
    <metric>et4</metric>
    <metric>et5</metric>
    <enumeratedValueSet variable="n">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="period">
      <value value="500"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="n-seasonal">
      <value value="10"/>
      <value value="7"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="xh">
      <value value="80"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="memory-length">
      <value value="9"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="infoswitch">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
